%global hash      8b3bdb6f0dc656b3e5e2f913dbb90cc44b05ae97
%global hashShort 8b3bdb6

Name:           maven-archetype
Version:        3.2.1
Release:        %mkrel 0.%{hashShort}.1
Group:          Development/Java
Summary:        Maven project templating toolkit

# Most of the code is under ASL 2.0, but some bundled jdom sources are
# under ASL 1.1
License:        ASL 2.0 and ASL 1.1
URL:            https://maven.apache.org/archetype/
Source0:        https://github.com/apache/maven-archetype/archive/%{hash}.zip

# We only use groovy for running a post generation script,
# removing this continues the old behaviour of ignoring it
Patch1: 0001-Avoid-reliance-on-groovy.patch

# Port to commons-lang3
Patch3: 0003-Port-to-commons-lang3.patch

BuildArch:      noarch
#ExclusiveArch:  %%{java_arches} noarch

BuildRequires:  maven-local
BuildRequires:  mvn(commons-io:commons-io)
BuildRequires:  mvn(net.sourceforge.jchardet:jchardet)
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.apache.maven:maven-artifact)
BuildRequires:  mvn(org.apache.maven:maven-core)
BuildRequires:  mvn(org.apache.maven:maven-model)
BuildRequires:  mvn(org.apache.maven:maven-parent:pom:)
BuildRequires:  mvn(org.apache.maven:maven-settings)
BuildRequires:  mvn(org.apache.maven:maven-settings-builder)
BuildRequires:  mvn(org.apache.maven.shared:maven-artifact-transfer)
BuildRequires:  mvn(org.apache.maven.shared:maven-invoker)
BuildRequires:  mvn(org.apache.maven.wagon:wagon-provider-api)
BuildRequires:  mvn(org.apache.velocity:velocity)
BuildRequires:  mvn(org.codehaus.modello:modello-maven-plugin)
BuildRequires:  mvn(org.codehaus.plexus:plexus-component-annotations)
BuildRequires:  mvn(org.codehaus.plexus:plexus-component-metadata)
BuildRequires:  mvn(org.codehaus.plexus:plexus-utils)
BuildRequires:  mvn(org.codehaus.plexus:plexus-velocity)
BuildRequires:  mvn(org.codehaus.plexus:plexus-xml)
BuildRequires:  mvn(org.jdom:jdom)
BuildRequires:  icu4j
BuildRequires:  apache-commons-collections


%description
Archetype is a Maven project templating toolkit. An archetype is
defined as an original pattern or model from which all other things of
the same kind are made. The names fits as we are trying to provide a
system that provides a consistent means of generating Maven
projects. Archetype will help authors create Maven project templates
for users, and provides users with the means to generate parameterized
versions of those project templates.

Using archetypes provides a great way to enable developers quickly in
a way consistent with best practices employed by your project or
organization. Within the Maven project we use archetypes to try and
get our users up and running as quickly as possible by providing a
sample project that demonstrates many of the features of Maven while
introducing new users to the best practices employed by Maven. In a
matter of seconds a new user can have a working Maven project to use
as a jumping board for investigating more of the features in Maven. We
have also tried to make the Archetype mechanism additive and by that
we mean allowing portions of a project to be captured in an archetype
so that pieces or aspects of a project can be added to existing
projects. A good example of this is the Maven site archetype. If, for
example, you have used the quick start archetype to generate a working
project you can then quickly create a site for that project by using
the site archetype within that existing project. You can do anything
like this with archetypes.

You may want to standardize J2EE development within your organization
so you may want to provide archetypes for EJBs, or WARs, or for your
web services. Once these archetypes are created and deployed in your
organization's repository they are available for use by all developers
within your organization.


%package javadoc
Summary: API documentation for %{name}

%description    javadoc
%{summary}.

%package catalog
Summary: Maven Archetype Catalog model

%description catalog
%{summary}.

%package descriptor
Summary: Maven Archetype Descriptor model

%description descriptor
%{summary}.

%package common
Summary: Maven Archetype common classes
# Registry module was obsoleted and removed by upstream F31
Obsoletes: %{name}-registry <= 3.1.1-1
# Plugin module was obsoleted and removed by upstream F37
Obsoletes: %{name}-plugin < 3.2.0-3

%description common
%{summary}.

%package packaging
Summary: Maven Archetype packaging configuration for archetypes

%description packaging
%{summary}.

%prep
%setup -q -n %{name}-%{hash}
%patch -P 1 -p1
%patch -P 3 -p1

# Not needed for RPM builds
%pom_remove_plugin -r :apache-rat-plugin

# Add OSGI info to catalog and descriptor jars
pushd archetype-models/archetype-catalog
    %pom_xpath_remove "pom:project/pom:packaging"
    %pom_xpath_inject "pom:project" "<packaging>bundle</packaging>"
    %pom_xpath_inject "pom:build/pom:plugins" "
      <plugin>
        <groupId>org.apache.felix</groupId>
        <artifactId>maven-bundle-plugin</artifactId>
        <extensions>true</extensions>
        <configuration>
          <instructions>
            <_nouses>true</_nouses>
            <Export-Package>org.apache.maven.archetype.catalog.*</Export-Package>
          </instructions>
        </configuration>
      </plugin>"
popd
pushd archetype-models/archetype-descriptor
    %pom_xpath_remove "pom:project/pom:packaging"
    %pom_xpath_inject "pom:project" "<packaging>bundle</packaging>"
    %pom_xpath_inject "pom:build/pom:plugins" "
      <plugin>
        <groupId>org.apache.felix</groupId>
        <artifactId>maven-bundle-plugin</artifactId>
        <extensions>true</extensions>
        <configuration>
          <instructions>
            <_nouses>true</_nouses>
            <Export-Package>org.apache.maven.archetype.metadata.*</Export-Package>
          </instructions>
        </configuration>
      </plugin>"
popd

# Remove ivy as a runtime dep
%pom_remove_dep org.apache.ivy:ivy archetype-common

%pom_remove_dep  org.sonatype.aether:
pushd archetype-common
%pom_remove_dep  org.sonatype.aether:
popd

# Disable processing of test resources using ant
%pom_remove_plugin org.apache.maven.plugins:maven-antrun-plugin archetype-common

# Don't build the maven-plugin
%pom_disable_module maven-archetype-plugin

%build
%mvn_package :archetype-models maven-archetype
# Tests are skipped due to missing test dependencies
%mvn_build -f -s -- -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8 -Dsource=1.8 -DdetectJavaApiLink=false

%install
%mvn_install

%files -f .mfiles-maven-archetype
%license NOTICE.txt

%files catalog -f .mfiles-archetype-catalog

%files descriptor -f .mfiles-archetype-descriptor

%files common -f .mfiles-archetype-common
%license NOTICE.txt

%files packaging -f .mfiles-archetype-packaging

%files javadoc -f .mfiles-javadoc
%license NOTICE.txt



%changelog
* Wed May 22 2024 ns80 <ns80> 3.2.1-0.8b3bdb6.1.mga10
+ Revision: 2065965
- update to the next pre-release for java 21

* Mon Jan 02 2023 daviddavid <daviddavid> 3.2.0-4.mga9
+ Revision: 1928801
- obsolete plugin module

* Fri Dec 16 2022 daviddavid <daviddavid> 3.2.0-3.mga9
+ Revision: 1923741
- Don't build the maven plugin, nothing uses it in Mageia

* Sat Mar 26 2022 umeabot <umeabot> 3.2.0-2.mga9
+ Revision: 1827564
- Mageia 9 Mass Rebuild

* Wed Aug 19 2020 neoclust <neoclust> 3.2.0-1.mga8
+ Revision: 1615891
- New version 3.2.0
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild

* Sun Nov 18 2018 guillomovitch <guillomovitch> 2.4-6.mga7
+ Revision: 1330825
- sync with fedora
- disable strict doc linting
  # Most of the code is under ASL 2.0, but some bundled jdom sources are
  # under ASL 1.1
  License:        ASL 2.0 and ASL 1.1

* Tue Sep 18 2018 umeabot <umeabot> 2.4-5.mga7
+ Revision: 1262723
- Mageia 7 Mass Rebuild

* Mon May 15 2017 neoclust <neoclust> 2.4-4.mga6
+ Revision: 1101530
- Rebuild maven-* packages

* Tue May 09 2017 neoclust <neoclust> 2.4-3.mga6
+ Revision: 1099920
- Port to new plexus-utils

* Thu Mar 03 2016 neoclust <neoclust> 2.4-2.mga6
+ Revision: 984659
- Sync with fedora
+ umeabot <umeabot>
- Mageia 6 Mass Rebuild

* Tue Nov 04 2014 dmorgan <dmorgan> 2.2-6.mga5
+ Revision: 795482
- Change buildrequires
+ umeabot <umeabot>
- Second Mageia 5 Mass Rebuild
- Mageia 5 Mass Rebuild

* Wed Dec 25 2013 dmorgan <dmorgan> 2.2-3.mga4
+ Revision: 560614
- Fix buildrequires
+ umeabot <umeabot>
- Mageia 4 Mass Rebuild

* Fri Jul 12 2013 dmorgan <dmorgan> 2.2-1.mga4
+ Revision: 453586
- New version

* Sat Jan 12 2013 umeabot <umeabot> 2.1-4.mga3
+ Revision: 359578
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Sep 12 2012 dmorgan <dmorgan> 2.1-3.mga3
+ Revision: 292737
- Export only proper OSGI packages
- Do not generate "uses" OSGI clauses
- Fix jetty namespace
- Add OSGI info to catalog.jar
+ gil <gil>
- build fix added new BR ant (depmap and pom file for ant-antlr)

* Mon Jan 09 2012 gil <gil> 2.1-2.mga2
+ Revision: 193722
- build fix added new BR jetty-maven-plugins
- increased release
- build fix
  changed ant groupid in archetype-common pom
  replaced plexus-maven-plugin with component-metadata in parent pom

* Sun Dec 25 2011 dmorgan <dmorgan> 2.1-1.mga2
+ Revision: 187586
- imported package maven-archetype


* Tue Sep 20 2011 Stanislav Ochotnicky <sochotnicky@redhat.com> - 2.1-2
- Add depmap explanation
- Omit javadoc.sh from javadocs
- Add explicit maven NVR that is needed

* Wed Sep 14 2011 Stanislav Ochotnicky <sochotnicky@redhat.com> - 2.1-1
- Initial version of the package
